@SCF/DFT single point
*
* SCF/DFT single energy
*
&GATEWAY
&SEWARD
&SCF
&GRID_IT

@SCF/DFT geometry optimization
*
* SCF/DFT geometry optimization
*
&GATEWAY
>>DO WHILE
&SEWARD
&SCF
&SLAPAF
>>ENDDO
&GRID_IT

@SCF/DFT geo. opt. and freq. calculation
*
* SCF/DFT geometry optimization and frequency calculation
*
&GATEWAY
>>DO WHILE
&SEWARD
&SCF
&SLAPAF
>>ENDDO
&MCKINLEY
&GRID_IT

@MP2 single point
*
* MP2 single energy
*
&GATEWAY
&SEWARD
&SCF
&MBPT2
&GRID_IT

@MP2 geometry optimization
*
* MP2 geometry optimization
*
&GATEWAY
>>DO WHILE
&SEWARD
&SCF
&MBPT2
&SLAPAF
>>ENDDO
&GRID_IT

@MP2 geo. opt. and freq. calculation
*
* MP2 geometry optimization and frequency calculation
*
&GATEWAY
>>DO WHILE
&SEWARD
&SCF
&MBPT2
&SLAPAF
>>ENDDO
&MCKINLEY
&GRID_IT

@CASSCF/RASSCF single point
*
* CASSCF/RASSCF single energy
*
&GATEWAY
&SEWARD
&SCF
&RASSCF
LUMORB
&GRID_IT

@CASSCF/RASSCF geometry optimization
*
* CASSCF/RASSCF geometry optimization
*
&GATEWAY
>> COPY _Start_Orbitals $Project.RasOrb
>>DO WHILE
&SEWARD
&RASSCF
LUMORB
&SLAPAF
>>ENDDO
&GRID_IT

@CASSCF/RASSCF geo. opt. and freq. calculation
*
* CASSCF/RASSCF geometry optimization and frequency calculation in RASSCF level
*
&GATEWAY
>> COPY _Start_Orbitals $Project.RasOrb
>>DO WHILE
&SEWARD
&RASSCF
LUMORB
&SLAPAF
>>ENDDO
&MCKINLEY

@CASPT2/MS-CASPT2 single point
*
* CASPT2/MS-CASPT2 single energy
*
&GATEWAY
&SEWARD
&SCF
&RASSCF
LUMORB
&CASPT2
&GRID_IT

@CASPT2/MS-CASPT2 geometry optimization
*
* CASPT2/MS-CASPT2 geometry optimization
*
&GATEWAY
>> COPY _Start_Orbitals $Project.RasOrb
>>DO WHILE
&SEWARD
&RASSCF
LUMORB
&CASPT2
&SLAPAF
>>ENDDO

@CASPT2/MS-CASPT2 geo. opt. and freq. calculation
*
* CASPT2/MS-CASPT2 geometry optimization and frequency calculation
*
&GATEWAY
>> COPY _Start_Orbitals $Project.RasOrb
>>DO WHILE
&SEWARD
&RASSCF
LUMORB
&CASPT2
&SLAPAF
>>ENDDO
&MCKINLEY

@Localized Molecular Orbitals for CASSCF/RASSCF
*
* Generating Starting Orbitals for CASSCF/RASSCF in ANO-RCC-MB
*
&GATEWAY
Basis=ANO-RCC-MB
Group=Full
RICD
&SEWARD
&SCF
&Localisation; Occu; FileOrb=$Project.ScfOrb
&Localisation; Virt; FileOrb=$Project.LocOrb
&Grid_it; All; FileOrb=$Project.LocOrb
>>> UNIX molcas gv $Project.grid
&RASSCF; FileOrb=$Project.GvOrb
&Grid_it; All; FileOrb=$Project.RasOrb
>>> UNIX molcas gv $Project.grid

@Localized Atomic Orbitals for CASSCF/RASSCF
*
* Generating Starting Orbitals for CASSCF/RASSCF
*
&GATEWAY
Basis=ANO-RCC-MB
Group=Full
RICD
&Localisation; All; FileOrb=$Project.GssOrb
&Grid_it; All; FileOrb=$Project.LocOrb
>>> UNIX molcas gv $Project.grid
&RASSCF; FileOrb=$Project.GvOrb
&Grid_it; All; FileOrb=$Project.RasOrb
>>> UNIX molcas gv $Project.grid

@SCF Orbitals for CASSCF/RASSCF
*
* Generating Starting Orbitals for CASSCF/RASSCF in ANO-RCC-MB
*
&GATEWAY
Basis=ANO-RCC-MB
Group=Full
RICD
&SEWARD
&SCF
&Grid_it; All; FileOrb=$Project.ScfOrb
>>> UNIX molcas gv $Project.grid
&RASSCF; FileOrb=$Project.GvOrb
&Grid_it; All; FileOrb=$Project.RasOrb
>>> UNIX molcas gv $Project.grid

@Expand Orbitals from one basis set to another
*
* Generate a set of orbitals based on orbitals from a smaller basis set
*
&Gateway; RICD
>>> COPY $Project.RunFile RUNFIL1
&Gateway; RICD
>>> COPY $Project.RunFile RUNFIL2
>>> COPY External_Orbital_File $Project.RasOrb_External
&EXPBAS; FileOrb=$Project.RasOrb_External
&SEWARD
&RASSCF; FileOrb=$Project.ExpOrb

@MEP with surface hopping
*
* MEP with surface hopping
*
&Gateway
>> COPY _Start_Orbitals $Project.RasOrb
>> Do While
&SEWARD
&RASSCF; LUMORB;
&RASSI; HOP
&Slapaf
MEP-Search
nMEP=10
MaxStep=0.1
>> EndDo
&GRID_IT; ALL

@Computation of Spectrum
*
* Compute a spectrum
*
&Gateway
>> COPY _Start_Orbitals $Project.RasOrb
&SEWARD
&RASSCF
&CASPT2
>> COPY $Project.JobMix JOB001
&RASSI; EJOB

