#! /usr/bin/env perl

#
# a script to convert InpOrb files from ver. 1.0 to 1.1
#
#
#
#

unless (@ARGV == 2) {help(); exit 1;}

$in=$ARGV[0];
$ut=$ARGV[1];

open(IN,"<$in") || die "file $in is not found\n";
open(UT,">$ut");
$l=<IN>;
if($l!~"#INPORB 1.0")
 {
   print "The file is not in InpOrb 1.0 format\n";
   exit 1;
 }
print UT "#INPORB 1.1\n"; 
$l=<IN>; 
print UT $l;
if($l=~/^\*/)
{
$l=<IN>; 
print UT $l;
}
$l=<IN>; 
print UT $l;
$l=<IN>;
print UT $l;
chomp($l);
$l=~s/^ +//;
($UHF,$SYM)=split(/ +/,$l);
print "Symmetries=$SYM\n";
if($UHF != 0 ) {
print "UHF is not supported\n";
exit 1;
}
$l=<IN>;
print UT $l;
$l=<IN>;
print UT $l;
chomp($l);
$l=~s/^ +//;
(@BAS)=split(/ +/,$l);
print "Basis= ";
for($i=0; $i<$SYM; $i++)
 {
   print $BAS[$i],' ';
 }
print "\n";
while($l=<IN>)
{
print UT $l;  
last if($l=~"#INDEX");
}
for($i=0; $i<$SYM; $i++)
 {
 $is=0;
  print UT "* 1234567890\n";
  $n=$BAS[$i] / 4;
  if($BAS[$i]%4 !=0 ) {$n++}
  for ($j=0; $j<$n; $j++)
    {
      $l=<IN>;
      $i1=substr($l,0,1);
      $i2=substr($l,1,1);
      $i3=substr($l,2,1);
      $i4=substr($l,3,1);
      $ST[$is]=$i1; $is++;
      $ST[$is]=$i2; $is++;
      $ST[$is]=$i3; $is++;
      $ST[$is]=$i4; $is++;
    }
  $is=0;  
  $first=0;
  for($j=0; $j<$BAS[$i]; $j++)
    {
      if ($j % 10 == 0) 
      { 
      if($first==1) { print UT "\n";}
      printf UT "%1d ",$is; 
       $is++; 
       if ($is==10) {$is=0};
      }
      if($first==0) { $first=1;}
      printf UT "%s",$ST[$j];
    }
 print UT "\n";   
 }
 
close(IN);
close(UT);

sub help() {
print "Tool to convert InpOrb 1.0 to 1.1 format\n";
print "usage: fixorb INPORB.old INPORB.new\n";

}
