#! /usr/bin/env perl
# $ this file belongs to the Molcas repository $
use 5.004;
#use strict;

our $debug	      	= 0;  		# Are we debugging?
our $fileIn       	= '';
our $action       	= 'split';
our $library         = '';
my  $tmpFileNameBase	= '_tmp';

if ($ARGV[0]) {
	$fileIn = $ARGV[0];
} else {
	die "\nSyntax: split.plx {fileIn} [action] [library]\n\n"
	   ."where:\n"
		."{fileIn}  in mandatory and is the file to split\n"
		."[action]  is either 'split' (default) or 'compile' (for both splitting and compilation).\n"
		."[library] is mandatory if [action]=compile is selected.\n"
		."          It specifies whitch library to put the compiled files.\n\n";
}

$action  = $ARGV[1] if ($ARGV[1]);
$library = $ARGV[2] if ($ARGV[2]);
unless ($action =~ /split/i || $action =~ /compile/i) {
	die "action must be either 'split' (default) or 'compile'.\n";
}

# First pick up the environmental variables with the compiler, flags, etc. to use.

my $FC     = '';
my $FFLAGS = '';
my $AR     = '';
my $RM     = '';
if ($action =~ /compile/i) {
	$FC     = $ENV{'FC'};
	$FFLAGS = $ENV{'FFLAGS'};
	$AR     = $ENV{'AR'};
	$RM     = $ENV{'RM'};
	
	die "Envrinmental variable 'FC' must be an executable FORTRAN compiler.\n" if (! -x $FC);
	die "Envrinmental variable 'AR' must be an executable archives manipulator.\n" if (! -x $AR);
	die "Envrinmental variable 'RM' must be an executable which removes files.\n" if (! -x $AR);
}

open (FILE, "< $fileIn") || die "Can't open $fileIn for reading.\n";

if ($debug) {
	open (DEBUG, "> debug.tmp") || die "Can't write to debug.tmp\n";
}

my $empty				= 1;			# If $empty is true after reading the source code, then we don't have any valid code
my $split_src_code 	= '';			# This variable stores the source code to be saved in the next split file
my $tmpFileCounter 	= 0;			# Just a counter to give the split files different names

while (my $line = <FILE>) {
	next if ($line =~ /^[cC*]/);
	my $saveLine = '';
	if ($debug) {
		$saveLine = $line if ($line =~ /(subroutine|function|program)/i);
	}

	$split_src_code .= $line;
	$line =~ s/\s//g;					# Remove all spaces
	if (lc($line) eq "end") {		# We are at the end of a subroutine, function, or program
		my $tmpFileName = sprintf "$fileIn$tmpFileNameBase"."_%04d_split.f",$tmpFileCounter;
		(my $tmpObjName = $tmpFileName) =~ s/.f$/.o/;

		open (TMP, "> $tmpFileName") || die "Can't write to $tmpFileName\n";
		print TMP "$split_src_code\n";
		close (TMP);

# Now compile if necersarry

		if ($action =~ /compile/i) {
			print  "$FC -c $FFLAGS $tmpFileName -o $tmpObjName\n";
			system "$FC -c $FFLAGS $tmpFileName -o $tmpObjName";
			print  "$AR cr $library $tmpObjName\n";
			system "$AR cr $library $tmpObjName";
		}
		
		$empty 		= 0;
		$split_src_code	= '';
		$tmpFileCounter++;
		next;
	} else {
		next;
	}
}

if ($debug) {
	close (DEBUG);
}

close (FILE);

if ($empty) {
	die "$fileIn did not contain any subroutines or functions.\n";
}

if ($action =~ /compile/i) {
	my $tmpFileName = "$fileIn$tmpFileNameBase"."_";
	print   "rm -f $tmpFileName*_split.f\n";
	system ("rm -f $tmpFileName*_split.f");
	print   "rm -f $tmpFileName*_split.o\n";
	system ("rm -f $tmpFileName*_split.o");
}

exit;

