#! /usr/bin/env perl
# find $ this file belongs to the Molcas repository $
###############################################################################
#                                                                              #
#    This script removes includes from                                         #
#           MOLCAS code                                                        #
#                                                                              #
#------------------------------------------------------------------------------#
#                                                                              #
# Author:  Valera Veryazov                                                     #
#          Dept. of Theoretical Chemistry                                      #
#          Lund, Sweden                                                        #
# Written: 2006                                                                #
#                                                                              #
#------------------------------------------------------------------------------#
#                                                                              #
# Copyright: all right reserved by authors.                                    #
#                                                                              #
#                                                                              #
################################################################################
use 5.004;
use POSIX;
use File::Find;

$MOLCAS=POSIX::getenv('MOLCAS');

$FLAGS=join(' ',@ARGV);
$FLAGS=$FLAGS." -P -traditional-cpp -Wno-trigraphs -I./ -I$MOLCAS/src/Include/ -I$MOLCAS/g/include/ -D_MOLCAS_";
#print 'cpp: ',$FLAGS,"\n";
#step 1 : uninclude #

opendir (SRC, "$MOLCAS/src");
@SRC=grep (/\w/ && -d "$MOLCAS/src/$_" , readdir (SRC));
closedir (SRC);

#zero pass. change all includes to #

foreach $src (@SRC)
{ 
opendir (INC, "$MOLCAS/src/$src");
@INC=grep (/\.[fi]/ && -f "$MOLCAS/src/$src/$_" , readdir (INC));
closedir (INC);
  foreach $file (@INC)
    {
    if($file=~/\.f$/ || $file=~/\.fh$/ || $file=~/\.inc/ )
    {
      rename("$MOLCAS/src/$src/$file","$MOLCAS/src/$src/$file.bak");
       open(IN,"<$MOLCAS/src/$src/$file.bak");
       open(UT,">$MOLCAS/src/$src/$file");
       while ($l=<IN>)
       {
          if($l=~/#include/)
	  {
	          $l=~s/</"/;
	          $l=~s/>/"/;
	  
	  }
          if( $l=~/^[ \t]*include /i )
	    {
	      if($l=~/^[!cC*#]/)
	       {
	          $l=~s/</"/;
	          $l=~s/>/"/;
               }
              else
	       {
	        if($l=~/=/)
		{
		
		}
		else
		{
	          $l=~s/.*include /#include /i;
		  $l=~s/'/"/g;
		  $l=~s/!.*$//;
	#	  print UT $l;
#"'
	        }
	        }
	     }  
           print UT $l;
	}
	close(IN);
	close(UT);   
      unlink("$MOLCAS/src/$src/$file.bak");
    }
    }


}
# exit;
# actual job
clean();
clean();
clean();

clean2();



sub clean()
{
       $elim=0;
foreach $src (@SRC)
{ 
opendir (INC, "$MOLCAS/src/$src");
@INC=grep (/\.[fi]/ && -f "$MOLCAS/src/$src/$_" , readdir (INC));
closedir (INC);
  foreach $file (@INC)
    {
    if( $file=~/\.fh$/ || $file=~/\.inc/ )
    {
#    print "Process $file\n";
      rename("$MOLCAS/src/$src/$file","$MOLCAS/src/$src/$file.bak");
      open(FLIN,"<$MOLCAS/src/$src/$file.bak");
      open(FLUT,">$MOLCAS/src/$src/$file");
      while($l=<FLIN>)
      {
         if($l=~/^#include/)
	   {
	      $keep=$l;
	      chomp($l);
	      $l=~s/#include//;
	      $l=~s/"//g;
	      $l=~s/ //g;
	      $found=0;
#	      print ">$l<\n";
	      if( -f "$MOLCAS/src/$src/$l")
	        {
		   $incfile="$MOLCAS/src/$src/$l";
		   $found=1;
		   $elim++;
		}
	      else
	        {
	        if ( -f "$MOLCAS/src/Include/$l")
	         {
		   $incfile="$MOLCAS/src/Include/$l";
		   $found=1;
		   $elim++;
		  }
	         }
	      if($found==0)
	      	 {
		    print "Can't locate $l\n";
		    print FLUT $keep;
		 }
	      else
	         {
		    open(FINC,"<$incfile") || die $!;
		    while($ll=<FINC>)
		     {
		       print FLUT $ll;
		     }
		    close(FINC);
		 }	 
	   }
	  else
	  {
	    print FLUT $l;
	  } 
      }      
       close(FLIN);
       close(FLUT);
       unlink("$MOLCAS/src/$src/$file.bak");
    }}}
   
 print "Eliminate ",$elim,"\n";
}
sub clean2()
{
foreach $src (@SRC)
{ 
opendir (INC, "$MOLCAS/src/$src");
@INC=grep (/\.[fi]/ && -f "$MOLCAS/src/$src/$_" , readdir (INC));
closedir (INC);
  foreach $file (@INC)
    {
    if( $file=~/\.f$/ || $file=~/\.fh$/ || $file=~/\.inc/ )
    {
      rename("$MOLCAS/src/$src/$file","$MOLCAS/src/$src/$file.bak");
      open(FLIN,"<$MOLCAS/src/$src/$file.bak");
      open(FLUT,">$MOLCAS/src/$src/$file");
      while($l=<FLIN>)
      {
         if($l=~/^#include/)
	   {
	      $keep=$l;
	      chomp($l);
	      $l=~s/#include//;
	      $l=~s/"//g;
	      $l=~s/ //g;
	      $found=0;
	      if( -f "$MOLCAS/src/$src/$l")
	        {
		   $incfile="$MOLCAS/src/$src/$l";
		   $found=1;
		}
	      else
	        {
	        if ( -f "$MOLCAS/src/Include/$l")
	         {
		   $incfile="$MOLCAS/src/Include/$l";
		   $found=1;
		  }
	         }
	      if($found==0)
	      	 {
		    print FLUT $keep;
		 }
	      else
	         {
		    open(FINC,"<$incfile");
		    while($ll=<FINC>)
		     {
		       print FLUT $ll;
		     }
		    close(FINC);
		 }	 
	   }
	  else
	  {
	    print FLUT $l;
	  } 
      }      
       close(FLIN);
       close(FLUT);
       unlink("$MOLCAS/src/$src/$file.bak");
    }}}

}
