if ($#ARGV > -1 ) 
 { $molcasdir=shift @ARGV; 
   if (!( -f "$molcasdir/.molcasversion" || -f "$molcasdir/.molcashome")  ) {die("$molcasdir is an invalid Molcas directory\n"); } }

open FIN,"pwd |"; $currentdir=<FIN>; chop $currentdir; close FIN;
print "current directory =$currentdir\n"; 
open FIN,"which bash |"; $bash=<FIN>; chop $bash; close FIN;
if (grep(/no bash/,$bash)) {die("no bash available ...\n");}
system("ln -s COLUMBUS.7.1 COLUMBUS"); 

open FIN,"<COLUMBUS/install.config";
$locmpi=0;
while (<FIN>) { if (/LOCMPI/) {$orig_locmpi=$_;chop ; s/^.*=//; $locmpi=$_; last;}} 
close FIN; 

print "adding environment variables to COLUMBUS/runcolmol\n";
open FIN,"<COLUMBUS/runcolmol" || die ("could not find COLUMBUS/runcolmol");
@colmol=<FIN>; close FIN;
shift @colmol;
open FIN,">COLUMBUS/runcolmol";
print FIN "#!$bash\n";
print FIN "export COLUMBUS=$currentdir/COLUMBUS\n";
if ($molcasdir) 
  { print FIN "export MOLCAS=$molcasdir\n";}
else
  { print FIN "export MOLCAS=$currentdir/MOLCAS\n";}
print FIN "export MPIMAIN=$currentdir/$locmpi\n";
#print FIN "export LD_LIBRARY_PATH=$currentdir/syslibs:$ENV{LD_LIBRARY_PATH}\n";
for ($i=0; $i<=$#colmol; $i++) {print $colmol[$i]; 
                                if (! grep(/^export/i,$colmol[$i])) {print FIN $colmol[$i];}};
close FIN;

open FD,"which perl|"; $perlversion=<FD>; close FD; 
open FD,"which bash|"; $bashversion=<FD>; close FD; 

if ($molcasdir) 
 { print "adjusting $molcasdir/data/columbus.prgm ... \n";
   system("cp MOLCAS/data/columbus.prgm $molcasdir/data/columbus.prgm");
   print "adjusting $molcasdir/data/prgms.cntrl ... \n";
   open FD,"<$molcasdir/data/prgms.cntrl"; @prgms=<FD>; close FD; 
   if ( ! grep(/columbus.prgm/,@prgms) ) 
    { print "... adding line (columbus) data/columbus.prgm \n"; 
      push @prgms, "(columbus) data/columbus.prgm \n"; 
      open FD,">$molcasdir/data/prgms.cntrl"; 
      print FD sort @prgms;
      close FD;
    }
 }
else
 { foreach $mfile ("molcas.rte","Symbols")
   { print "adjusting $currentdir/MOLCAS/$mfile \n"; 
     open FD,"<$currentdir/MOLCAS/$mfile"; @symbs=<FD>; close FD;
     for ($i=0; $i<=$#symbs ; $i++)
      { if (grep (/^RUNBINARY/,$symbs[$i])) 
          { if (grep(/LD_LIBRARY_PATH/,$symbs[$i])) 
             {$symbs[$i]=~s/(^RUNBINARY.*=)(LD_LIB.* )(.*$)/\1 LD_LIBRARY_PATH=$currentdir\/syslibs \3/;  }
             else 
             {$symbs[$i]=~s/(^RUNBINARY.*=)(.*$)/\1 LD_LIBRARY_PATH=$currentdir\/syslibs \2/; }}}
      open FD,">$currentdir/MOLCAS/$mfile"; print FD @symbs; close FD; 
    }
 }

if ($locmpi)
{ open FIN,">COLUMBUS/install.config";
  print FIN $orig_locmpi;
#mpich1
#  print FIN "MPI_STARTUP \$MPIMAIN/bin/mpirun -np _NPROC_  _EXE_ _EXEOPTS_ \n";
#mpich2
   print FIN "MPI_STARTUP \$MPIMAIN/bin/mpiexec -np _NPROC_  _EXE_ _EXEOPTS_ \n";
  print FIN "PERL $perlversion";
  print FIN "BASH $bashversion";
  close FIN; }
$perlversion=~s/^/#!/;
$bashversion=~s/^/#!/;
# modify header of all perlscripts 
$rc=&systemconfig;
if ($rc) {die("aborting installation - unsupported hardware\n");}
@perlsc=("COLUMBUS/tmodel.pl","COLUMBUS/bugreport.pl","COLUMBUS/verify.pl");
@bashsc=("COLUMBUS/runcolmol","runtests.sh","usersetup.sh");
print "modifying perl header ... \n"; 
foreach $p (@perlsc) {open FIN,"<$p"; @tmp=<FIN>; close FIN; $tmp[0]="$perlversion"; 
                      open FIN,">$p"; print FIN @tmp; close FIN;}
print "modifying bash header ... \n"; 
foreach $p (@bashsc) {open FIN,"<$p"; @tmp=<FIN>; close FIN; $tmp[0]="$bashversion"; 
                      open FIN,">$p"; print FIN @tmp; close FIN;}

#additional checks for setup of mpi
open  FIN,"$currentdir/$locmpi/bin/tarch|"; $mpiarch=<FIN>; close FIN; chop $mpiarch;
open  FIN,"hostname|"; $hostname=<FIN>; close FIN;

#modify default machine file: 
print "setting up default machine file for this host($currentdir/$locmpi/share/machines.$mpiarch)\n";
open FIN,">$currentdir/$locmpi/share/machines.$mpiarch";
for ($i=1; $i<=16; $i++) {print FIN $hostname;} 
close FIN; 

##### MPICH1.2.7 ####
#print "adjusting default path settings in $currentdir/$locmpi/bin/mpirun ...\n"; 
#open FIN,"<$currentdir/$locmpi/bin/mpirun"; @mpirun=<FIN>; close FIN;
## find line prefix=
# for ($i=0; $i<=$#mpirun; $i++)
# { if (grep(/^prefix=/,$mpirun[$i])) {$mpirun[$i]="prefix=$currentdir/$locmpi\n"; last;}}
#open FIN,">$currentdir/$locmpi/bin/mpirun"; print FIN @mpirun; close FIN;
######MPICH2 ######
system("./mpich2mod.sh");

if (-d "COLUMBUS.7.0") {
@liste=("tmodel.pl","verify.pl","mpitest.x","bugreport.pl","runcolmol","columbus.exe","install.config");
foreach $p (@liste) {system("cp COLUMBUS.7.1/$p COLUMBUS.7.0/$p");} } 

#checking availability of proper id_dsa.pub in authorized_keys
print "checking properly setup ssh ...\n";
open FIN,"ps axl | grep 'sshd -D' | wc -l|";
$found=<FIN>; close FIN;  
if ($found != 3) {print "WARNING ... ssh daemon (sshd) does not seem to be active -- needs activiation! \n";}
if ( ! -d "$ENV{HOME}/.ssh" ) {print "your ssh is not set up ... run ssh-keygen -t dsa !\n";}
@pub=0;
while (<$ENV{HOME}/.ssh/*.pub>)
{ print "found public key files: $_\n";
  open FIN,"<$_"; $tmp=<FIN>; $tmp=~s/^.* //; chop $tmp;  push @pub,$tmp; close FIN;}

if ( $#pub == -1 ) {print "no public key files available in $ENV{HOME}/.ssh  .... prepare them!\n"; }
if ( ! -f "$ENV{HOME}/.ssh/authorized_keys" ) 
   { print "there is no authorized keys file ... prepare it!\n";}
else
 { open FIN,"<$ENV{HOME}/.ssh/authorized_keys"; @akeys=<FIN>; close FIN;

$found=0;
foreach $k (@akeys)
 { $k=~s/^.* //; chop $k; 
   $found += grep(/\b$k\b/,@pub); }
if (! $found ) {print "authorized_keys file does not contain the required ssh public keys ... check!\n";}
} 

print "Please check, that you can run\n            ssh $ENV{USER}\@$hostname     ***without*** using a password!\n";
print "Note, that ssh access must be allowed in /etc/hosts.allow and must not be blocked by the firewall setup!\n"; 
print "Hint: on stand-alone systems *without* network connection it may be necessary to add the hostname $hostname ";
print "      to the localhost line in /etc/hosts\n";
print "\n\n\n\n";

#print "modifying runtests.sh ...\n";
#
#open FIN,"<runtests.sh"; @tmp=<FIN>; close FIN;
#open FIN,">runtests.sh";
#while ($#tmp>-1)
# { $_=shift @tmp; if (/\/mpitest.x *$/) { print FIN "LD_LIBRARY_PATH=$currentdir/syslibs  $currentdir/$locmpi/bin/mpirun -np 4 $currentdir/COLUMBUS/mpitest.x \n";}
#                   else {print FIN ;}
# }
#close FIN;
      
if ($molcasdir)
 { print "setup for locally available Molcas version \n";
   print "   $molcasdir   Version:";
   open FIN,"$molcasdir/.molcasversion"; $mversion=<FIN>; close FIN; 
   print $mversion; 
   print "For production purposes, modify the MOLCAS environment variable in \n";
   print "$currentdir/COLUMBUS/runcolmol to reflect your native installation and \n";
   print "re-run the testcases, as to make sure that there are no incompatibilities \n";
   print "at the level of binary MOLCAS data files \n\n";

   print "COLUMBUS/columbus.exe is configured to start-up by the accompanying MPI library\n";
   print "(cf. settings in COLUMBUS/install.config) \n";
   print "For parallel MOLCAS operation this startup string is completely independent of \n";
   print "cf. settings in $molcasdir/molcas.rte and MOLCAS environment variables.\n\n";
  
   open FIN,"LD_LIBRARY_PATH=$currentdir/syslibs  ldd COLUMBUS/ciudg.x|"; my @x=<FIN>; close FIN;
   if ((! grep(/not dynamically/,@x)) && grep(/not found/,@x))
  { die("inconsistent shared libraries \n @x"); }
 }

else
 { open FIN,"<MOLCAS/.molcasversion" || die ("could not find MOLCAS/.molcasversion\n"); 
   $mversion=<FIN>; close FIN; chop$mversion; 
print "It is recommended, to verify the set of test cases with the MOLCAS version \n";
print "($mversion) accompanying this extract of COLUMBUS 7.1 \n";
print "Thus, it is necessary to make the MOLCAS license file accessible \n";
print "to this MOLCAS version, either by copying the license file to $currentdir/MOLCAS \n";
print "or by setting the MOLCAS specific environment variables\n\n";

print "COLUMBUS/columbus.exe is configured to start-up by the accompanying MPI library\n";
print "(cf. settings in COLUMBUS/install.config) \n";
print "For parallel MOLCAS operation this startup string is completely independent of \n";
print " cf. settings in MOLCAS/molcas.rte and MOLCAS environment variables.\n\n";

   open FIN,"LD_LIBRARY_PATH=$currentdir/syslibs  ldd MOLCAS/bin/molcas.exe|"; my @x=<FIN>; close FIN;
   if ((! grep(/not dynamically/,@x)) && grep(/not found/,@x))
   { die("inconsistent shared libraries \n @x");}
}

print "The development version of Columbus cannot be guaranteed to be free of bugs nor\n";
print "are all features available in Columbus already fully and sensibly accessible from \n";
print "the interfaced version (consult documentation on advanced usage within this environment).\n\n";

print "Bug reports are appreciated; please describe the problem concisely and run the script \n";
print "\"$currentdir/COLUMBUS/bugreport.pl <jobname> \" from the directory, where the job in question \n";
print "has been initiated, attach the resulting file \"bugreport<date>.tgz\" to the email \n";
print "and send to th.mueller\@fz-juelich.de\n";

exit 0;

sub systemconfig
 {
my $kbtogb=.00000095367431640625;
# determine memory  

open MDF,"</proc/meminfo";
while (<MDF>)
 { chop;
   if (/^MemTotal:/i) { s/^.*: *//; s/ *kB$//; $memory=$_;next;}
   if (/^SwapTotal:/i) {s/^.*: *//; s/ *kB$//; $swapspace=$_;next;}
 }
close MDF;
open MDF,"df| grep /dev/shm|";
my $mdf=<MDF>;
close MDF;
chop $mdf;
#Dateisystem    1K-Blöcke  Benutzt Verfügbar Verw% Eingehängt auf
my @mdf = split(/\s+/,$mdf);
my $sharedmem_max=$mdf[1];
my $sharedmem_avail=$mdf[3];
printf "total amount of physical memory  %10d kB ( %5.2f GB ) \n",$memory,$memory*$kbtogb;
printf "maximum shared memory            %10d kB ( %5.2f GB ) \n" .
       "available shared memory          %10d kB ( %5.2f GB ) \n",$sharedmem_max, $sharedmem_max*$kbtogb,
                                                               $sharedmem_avail,$sharedmem_avail*$kbtogb;
printf "total amount of swap space       %10d kB ( %5.2f GB ) \n",$swapspace,$swapspace*$kbtogb;

#determine processor type and capabilities

my ($model,$cache,$flags,$platform,$kernel);
open MSYS,"uname -i |"; $platform=<MSYS>; chop $platform; close MSYS;
open MSYS,"uname -r |"; $kernel=<MSYS>; chop $kernel; close MSYS;
open CPU,"</proc/cpuinfo";
my $first=0;
while (<CPU>)
 { if (/^processor/) {if ($first) {last;} $first=1; next;}
   if (/^model name/) {chop;  s/^.*: //;$model=$_; next;}
   if (/^cache size/) {chop;  s/^.*: //;$cache=$_; next;}
   if (/^flags/) {  chop; s/^.*: //; $flags=$_;  next;}
}

printf "Linux kernel     :     %-10s \n", $kernel;
printf "Hardware platform:     %-10s \n",$platform;
printf "CPU model :            %-10s \n",$model;
printf "CPU cache :            %-10s \n",$cache;
#printf "CPU flags :            %s \n",$flags; 

my @flags=split(/\s+/,$flags);
if ( grep(/^sse/,@flags) ) {print "128 bit SIMD register ",join(",",grep(/^sse/,@flags)),"\n"; }
if ( grep(/^avx$/,@flags)) {print "256 bit SIMD register ",grep(/^avx$/,@flags),"\n";}
  else {print "no 256 bit SIMD register on board \n";}
if ( grep(/^avx2$/,@flags)) {print "512 bit SIMD register ",grep(/^avx2$/,@flags),"\n";}
  else { print "no 512 bit SIMD register on board \n";}

if ( $platform != "x86_64" ){print "Only x86_64 Linux Operating system supported\n"; return -1;}
return 0;
}

