#!/bin/bash
CURRENTDIR=`pwd`

if [ $# -eq 1 ]; then
if [ $1 == '-mpitest.x' ]; then
     MPITEST=1;
     SERIELL=0;
     PARALLEL=0;
elif [ $1 == '-seriel' ]; then
     MPITEST=0;
     SERIELL=1;
     PARALLEL=0;
elif [ $1 == '-parallel' ]; then
     MPITEST=0;
     SERIELL=0;
     PARALLEL=1;
else
    echo "usage: ./runtests.sh [-mpitest.x|-seriel|-parallel] "
    exit 
fi 
else
PARALLEL=1
SERIELL=1;
MPITEST=1;
fi 
  
if [ -d scratch ]; then 
 rm -rf scratch
fi 
mkdir scratch
cd scratch

 if [ $MPITEST -eq 1 ]; then
  echo "executing simple mpi test program (mpitest.x)"
# $CURRENTDIR/mpich1.2.7/bin/mpirun -np 4 $CURRENTDIR/COLUMBUS/mpitest.x 
  $CURRENTDIR/mpich2/bin/mpiexec -np 4 $CURRENTDIR/COLUMBUS/mpitest.x 
 fi

 if [ $SERIELL -eq 1 ]; then

 for i in 0 1  6 7 8 9 10 11 2 20 22 
 do
  echo "executing seriel test case $i "
  cp $CURRENTDIR/TESTS/test$i.input .
  grep '^\*' test$i.input | grep -v '\-\-\-' | grep -v '\$'
  $CURRENTDIR/COLUMBUS/runcolmol test$i > test$i.logerr 2>&1
  $CURRENTDIR/COLUMBUS/verify.pl -config ../TESTS/test$i.config > test$i.verifyls 
 done
 fi 

 if [ $PARALLEL -eq 1 ]; then
 for i in 0 1 2 3 4 5 12 13 14 15 
 do
  echo "executing parallel test case ${i}p "
  cp $CURRENTDIR/TESTS/test${i}p.input .
  grep '^\*' test${i}p.input | grep -v '\-\-\-' | grep -v '\$'
  $CURRENTDIR/COLUMBUS/runcolmol test${i}p > test${i}p.logerr 2>&1 
  $CURRENTDIR/COLUMBUS/verify.pl -config ../TESTS/test${i}p.config > test${i}p.verifyls 
 done
fi 

   
